;;;
;;; The evaluator for mathematical expressions given an environment
;;; of values for variables.
;;;

evalmath[expr; env] =
  [constant-p[expr] --> const-val[expr];
   variable-p[expr] --> apply-env[env; var-name[expr]];
   negation-p[expr] --> minus[0; evalmath[operand[expr]; env]];
   otherwise -->
     {op1 = evalmath[operand1[expr]; env];
      op2 = evalmath[operand2[expr]; env] :
      [product-p[expr] --> times[op1; op2];
       quotient-p[expr] --> divide[op1; op2];
       sum-p[expr] --> plus[op1; op2];
       difference-p[expr] --> minus[op1; op2];
       power-p[expr] --> power[op1; op2]]}]

power[x; y] =
  [lessp[y; 0] --> divide[1; power[x; minus[0; y]]];
   eqp[y; 0] --> 1;
   otherwise --> times[x; power[x; minus[y; 1]]]]
