;;;
;;; The data access functions for "function environments".
;;;
empty-node-p[env-tree] = endp[env-tree]

tree-node-p[env-tree] = 
  [endp[env-tree] --> F;
   otherwise --> T]

empty-node = ()

make-tree-node[key; left-env; right-env; key-val] =
  list4[key; left-env; right-env; key-val]

key[tree-node] = first[tree-node]

left-env[tree-node] = second[tree-node]

right-env[tree-node] = third[tree-node]

key-value[tree-node] = fourth[tree-node]

defined-fn-p[env; name] =
  [empty-node-p[env] --> F;
   eq[name; key[env]] --> T;
   sym-lessp[name; key[env]] --> defined-fn-p[left-env[env]; name];
   otherwise --> defined-fn-p[right-env[env]; name]]

apply-fn-env[env; name] =
  [empty-node-p[env] --> error2[(Undefined function --); name];
   eq[name; key[env]] --> key-value[env];
   sym-lessp[name; key[env]] --> apply-fn-env[left-env[env]; name];
   otherwise --> apply-fn-env[right-env[env]; name]]

extend-fn-env[env; name; val] =
  [empty-node-p[env] -->
     make-tree-node[name; empty-node; empty-node; val];
   eq[name; key[env]] -->
     make-tree-node[name; left-env[env]; right-env[env]; val];
   sym-lessp[name; key[env]] -->
     make-tree-node
       [key[env]; extend-fn-env[left-env[env]; name; val];
        right-env[env]; key-value[env]];
   otherwise -->
     make-tree-node
       [key[env]; left-env[env];
        extend-fn-env[right-env[env]; name; val]; key-value[env]]]

null-fn-env = empty-node
