;;;
;;; This function contains the main driver functions for the
;;; Lisp-in-Lisp interpreter.
;;;
;;; The "interpret" function evaluates an expression (expr) in the
;;; context of a set of function and constant definitions (defs).
;;; It calls the "setup-envs-then-eval" auxiliary function to
;;; do the work of setting up the appropriate function and
;;; value environments before evaluating "expr".
;;;
interpret[defs; expr] =
  setup-envs-then-eval
    [null-fn-env; 
     extend-env
       [extend-env
         [extend-env[null-env; "F"; "F"]; 
          "T"; "T"]; 
        "otherwise"; "T"];
     defs; expr]

setup-envs-then-eval[fn-env; val-env; defs; expr] =
  [endp[defs] --> sl-eval[expr; fn-env; mark-global-frame[val-env]];
   fn-def-p[first[defs]] -->
     setup-envs-then-eval
       [extend-fn-env[fn-env; fn-name[first[defs]]; first[defs]];
        val-env; rest[defs]; expr];
   const-def-p[first[defs]] -->
     setup-envs-then-eval
       [fn-env;
        extend-env
          [val-env; const-name[first[defs]];
           sl-eval[const-val[first[defs]]; fn-env; val-env]];
        rest[defs]; expr]]
