.TH SMLISP 1 "August 2002" "CAN"
.SH NAME
smlisp \- Small Lisp Implementation
.SH SYNOPSIS
.B /usr/local/bin/smlisp
[
.I configfile
]
.SH DESCRIPTION
Small Lisp is a very small implementation of the LISP programming language.
It has been written for teaching purposes at the School of Computing Science
at Simon Fraser University. Small Lisp is based on McCarthy's original m-Lisp
representation of LISP. However, the distribution contains also various
utilities to translate m- to S-expressions, or the other way around.

The original Small Lisp package was distributed only with executables for the
MS-DOS operating system. This Linux binary distribution was compiled from the
Modula-3 source code using PM3, a Modula-3 implementation from the cole
Polytechnique de Montral.

For the complete grammar of the language refer to 
.I Symbolic Computing with LISP
(see details below) or the
.I Small Lisp Reference Manual
included in the distribution.

.SH USAGE
[
.I configfile
]
is an optional argument, and allows the user to read in additional
Small Lisp programs with pre-defined functionals. The
[
.I configfile
]
should contain a list of all files to be read in, each file on a
single line. If no configuration file is specified, the plain default
of the Small Lisp language is invoked by the interpreter.

Several interpreter commands are available in the interactive mode.
All start with a backslash on a single line. After invoking
.B smlisp,
the following interpreter commands can be used:
.IP "\fB/help"
prints out some reminders about using the interpreter.
.IP "\fB/quit"
stops the interpreter, returning control to the operating system. 
.IP "\fB/read"
.I smlispfile
reads in the list of Small Lisp definitions in
.I smlispfile\fP,
adding them to the current set.
.IP "\fB/reset"
[
.I configfile
]
clears all current definitions and optionally reads in a new
configuration from
.I configfile\fP.
.IP "\fB/save"
.I filename
saves all the interactively entered definitions into
.I filename\fP.
.IP "\fB/show"
.I function-name
prints out the current function definition associated with 
.I function-name\fP.
.IP "\fB/log"
[
.I logfile
]
closes any current log file and starts a new log on
.I logfile\fP,
if specified.

.SH IMPLEMENTATION LIMITS
A Small Lisp implementation may impose limits on the lengths of
source lines, identifiers, and symbolic atom names and may also
limit the range of representable numeric values.

This implementation limits the length of source lines to 254
characters. Consequently, identifiers and symbolic atom names
are also limited to this length, but no further limits are imposed.
The values of numeric atoms are restricted to the interval
[-2147483648, 2147483647]. Outside this range, an arithmetic underflow
or overflow occurs. For example:

minus[-2147483648; 1] --> 2147483647,

plus[2147483647; 1] --> -2147483648.

.SH UTILITY PROGRAMS
Apart from the main executable
.B smlisp
several utilities are provided to manipulate Small Lisp programs
in m- or S-Lisp representation:
.IP "\fBprettysl"
beautifies a program file containing Small Lisp 
functions and definitions. It may be invoked using the following
syntax:

.B prettysl
.I file1
[
.I file2
]\fP.

The list of definitions is read from
.I file1
and pretty-printed to
.I file2\fP,
if specified, or to the standard output, otherwise.
.IP "\fBslispify"
converts a Small Lisp program in m-Lisp form into its S-Lisp
equivalent. It may be invoked using the following syntax:

.B slispify
.I file1
[
.I file2
]\fP.

The list of definitions is read from
.I file1
and pretty-printed in S-Lisp form to
.I file2\fP,
if specified, or to standard output, otherwise.
.IP "\fBmlispify"
converts a Small Lisp program in S-Lisp form back into its m-Lisp
equivalent. It may be invoked using the following syntax:

.B mlispify
.I file1
[
.I file2
]\fP.

The list of definitions is read from
.I file1
and pretty-printed in m-Lisp form to
.I file2\fP,
if specified, or to standard output, otherwise.

.SH REFERENCES
The definite reference on Small Lisp is

    Robert D. Cameron and Anthony H. Dixon
    Symbolic Computing with LISP
    Prentice-Hall, Inc., 1992, ISBN 0-13-877846-9

.SH COPYRIGHT
This software is provided for use with the book Symbolic Computing
with Lisp, by Robert D. Cameron and Anthony H. Dixon, copyright
1992 by Prentice-Hall, Inc., a Division of Simon and Schuster,
Englewood Cliffs, New Jersey, 07632.

This software may be freely distributed, copied and/or modified,
provided that this copyright notice is included unchanged and that
all modifications are clearly indicated.

The Small Lisp web site is located at

http://www.cs.sfu.ca/~cameron/smlisp/

and the site for the Linux distribution at

http://www.uv.es/~tung/smlisp/

.SH CONTACT
Contact Michael M. Tung <michael.tung@uni-mainz.de> for questions related
to the Linux binary distribution. 
